Attribute VB_Name = "UTILS"
Sub ClimCalcIn()
Dim testmon As Double
For i = 1 To 4   'tmax, tmin, rad, prec
 Line Input #11, junk$
 For j = 1 To 12 ' months of the year
  'Input #11, testnum
  Input #11, testmon, b0(i, j), b1(i, j), b2(i, j), b3(i, j), b4(i, j), b5(i, j), b6(i, j)
 Next j
Next i
End Sub
Sub ClimCalc(Lat, Lon, Elev)
For i = 1 To 12
 TMaxGIS(i) = b0(1, i) + b1(1, i) * Lat + b2(1, i) * Lon + b3(1, i) * Lat ^ 2 + b4(1, i) * Lon ^ 2 + b5(1, i) * Lat * Lon + b6(1, i) * Elev
 TMinGIS(i) = b0(2, i) + b1(2, i) * Lat + b2(2, i) * Lon + b3(2, i) * Lat ^ 2 + b4(2, i) * Lon ^ 2 + b5(2, i) * Lat * Lon + b6(2, i) * Elev
 PARGIS(i) = b0(3, i) + b1(3, i) * Lat + b2(3, i) * Lon + b3(3, i) * Lat ^ 2 + b4(3, i) * Lon ^ 2 + b5(3, i) * Lat * Lon + b6(3, i) * Elev
 PrecGIS(i) = b0(4, i) + b1(4, i) * Lat + b2(4, i) * Lon + b3(4, i) * Lat ^ 2 + b4(4, i) * Lon ^ 2 + b5(4, i) * Lat * Lon + b6(4, i) * Elev
Next i
End Sub
Function f4(x)
 x = Int(x * 10000) / 10000
 c4 = "@@@@ "
 f4 = Format(Left$(Str(x), 4), c4)
End Function

Function f5(x)
 x = Int(x * 100000) / 100000
 c5 = "@@@@@ "
 f5 = Format(Left$(Str(x), 5), c5)
End Function

Function f6(x)
 x = Int(x * 1000000) / 1000000
 c6 = "@@@@@@ "
 f6 = Format(Left$(Str(x), 6), c6)
End Function

Function f7(x)
 x = Int(x * 10000000) / 10000000
 c7 = "@@@@@@@ "
 f7 = Format(Left$(Str(x), 7), c7)
End Function
'modified from 7->8  Aug 17 98  RF
Function f8(x)
 x = Int(x * 100000000) / 100000000
 c8 = "@@@@@@@@ "
 f8 = Format(Left$(Str(x), 8), c8)
End Function

Function f9(x)
 x = Int(x * 1000000000) / 1000000000
 c9 = "@@@@@@@@@ "
 f9 = Format(Left$(Str(x), 9), c9)
End Function

Function fil(stringv)

  l = Len(stringv)
  If l < 20 Then
    For i = l To 20
      strinv = stringv + " "
    Next i
  End If
  fil = stringv
End Function

Function Log10(x)
 Log10 = Log(x) / Log(10#)
End Function

Sub Max3(x, y, z)
  If x > y Then
    If x > z Then
      y = x
      z = x
    Else
      y = z
      x = z
    End If
  ElseIf y > z Then
    z = y
    x = y
  Else
    y = x
    z = x
  End If
End Sub

Sub plot(XTitle$, XMax, XMin, varnum, VarName$(), YMax(), YMin(), datnum, datx(), daty())
Static PColor(8)
outpt.DrawWidth = 2


XSize = outpt.ScaleWidth                                           'scale graph on page
YSize = outpt.ScaleHeight
TopLeftX = 750: TopLeftY = 1000
OriginX = 750: OriginY = YSize - 1000
TopRightX = XSize * 0.9: TopRightY = 1000

PColor(1) = 15: PColor(2) = 14: PColor(3) = 13: PColor(4) = 12     ' set colors for lines
PColor(5) = 11: PColor(6) = 10: PColor(7) = 9: PColor(8) = 8

XInc = (TopRightX - OriginX) / (XMax - XMin)                       ' spatial increment on X & Y axes
YInc = (TopRightY - OriginY) / (100 + YMin(0))
                
outpt.Visible = True: outpt.Cls
                                                                   
outpt.Line (TopLeftX, TopLeftY)-(OriginX, OriginY)                 ' draw axes and print XTitle
outpt.Line (OriginX, OriginY)-(TopRightX, OriginY)
outpt.CurrentX = XSize * 0.45: outpt.CurrentY = OriginY + 300: outpt.Print XTitle$
For i = 1 To 10                                                    ' draw tic labels on X and Y axes
  outpt.CurrentX = OriginX + (TopRightX - OriginX) * (i / 10)
  outpt.Line (outpt.CurrentX, OriginY)-(outpt.CurrentX, OriginY + 50)
  outpt.CurrentX = outpt.CurrentX - 100 * Int(Log10(XMax) + 1)
  outpt.CurrentY = OriginY + 100: outpt.Print Int(XMin + ((XMax - XMin) / 10) * i)
  outpt.CurrentY = (OriginY - (OriginY - TopLeftY) * i / 10) - 50
  outpt.CurrentX = OriginX - 700:  outpt.Print Left$(Str$((-YMin(0) + ((100 + YMin(0)) / 10) * i)), 4)
Next i

YZero = OriginY + (YInc * YMin(0))       ' draw zero line
outpt.Line (OriginX, YZero)-(TopRightX, YZero)

                               ' Add titles for max vals and line types
  outpt.CurrentY = 100: outpt.CurrentX = OriginX - 700: outpt.Print "Name"
  outpt.CurrentY = 300: outpt.CurrentX = OriginX - 700: outpt.Print "Line"
  outpt.CurrentY = 500: outpt.CurrentX = OriginX - 700: outpt.Print "Max."


For i = 1 To varnum            ' Add max vals and line types
 If YMax(i) <> 0 Or YMin(i) <> 0 Then
  dist = (TopRightX - OriginX) / 8
  outpt.CurrentY = 100: outpt.CurrentX = OriginX + dist * ((i - 1))
  outpt.Print VarName$(i)
  outpt.DrawStyle = i Mod 5
  outpt.CurrentX = OriginX + dist * ((i - 1))
  outpt.Line (outpt.CurrentX, outpt.CurrentY + 100)-(outpt.CurrentX + (0.8 * dist), outpt.CurrentY + 100), QBColor(PColor(i))
  outpt.CurrentX = OriginX + dist * ((i - 1))
  outpt.CurrentY = outpt.CurrentY + 100: outpt.Print Left$(Str$(YMax(i)), 6)
                                
                                ' find first point for this variable
  outpt.CurrentX = OriginX + (XInc * (datx(1) - XMin))
  outpt.CurrentY = OriginY + (YInc * ((daty(i, 1) - effYMin) / (YMax(i) - effYMin)) * (YMin(0) + 100))
 
  For j = 2 To datnum           ' plot rest of points for this variable
    newx = OriginX + (XInc * (datx(j) - XMin))
    effYMin = -(YMin(0) / 100) * YMax(i)
    newy = OriginY + (YInc * ((daty(i, j) - effYMin) / (YMax(i) - effYMin)) * (YMin(0) + 100))
    outpt.Line (outpt.CurrentX, outpt.CurrentY)-(newx, newy), QBColor(PColor(i))
  Next j
 End If
Next i


End Sub

Sub DropSite()
 ix = 0
 For i = 1 To nsites
  If DM.Text2 = sitefile(i) Then ix = i
  If DM.Text1 = sitelst(i) Then ix = i
 Next i
 If ix = 0 Then
   MsgBox ("No file by this name")
 Else
  test = MsgBox("Remove this file?", 1, "Warning!")
  If test = 1 Then
    test = MsgBox("Are you sure?", 1, "Warning!")
    If test = 1 Then
      PnET.SiteComb.RemoveItem ix - 1
      nsites = nsites - 1
      For i = ix To nsites
        sitelst(i) = sitelst(i + 1)
        sitefile(i) = sitefile(i + 1)
      Next i
      PnET.SiteComb = sitelst(1)
  '    Open "D:\pnet\data\pnetsite.lst" For Output As #5
      Open PnET.ProjPath + trunc(projfile(ThisProj)) + "\pnetsite.lst" For Output As #5
      Print #5, nsites
      For i = 1 To nsites
        Print #5, sitelst(i) + sitefile(i)
      Next i
      Close #5
    End If
  End If
 End If
End Sub

Sub DropVeg()
 ix = 0
 For i = 1 To ntypes
  If DM.Text2 = typfile(i) Then ix = i
  If DM.Text1 = typlst(i) Then ix = i
 Next i
 If ix = 0 Then
   MsgBox ("No file by this name")
 Else
  test = MsgBox("Remove this file?", 1, "Warning!")
  If test = 1 Then
    test = MsgBox("Are you sure?", 1, "Warning!")
    If test = 1 Then
      PnET.VegComb.RemoveItem ix - 1
      ntypes = ntypes - 1
      For i = ix To ntypes
          typlst(i) = typlst(i + 1)
          typfile(i) = typfile(i + 1)
      Next i
      PnET.VegComb = typlst(1)
      Close #5
'      Open "D:\pnet\data\pnetveg.lst" For Output As #5
      Open PnET.ProjPath + trunc(projfile(ThisProj)) + "\pnetveg.lst" For Output As #5
      Print #5, ntypes
      For i = 1 To ntypes
        Print #5, typlst(i) + typfile(i)
      Next i
      Close #5
    End If
  End If
 End If
End Sub

Sub KeepSite()
    
 ix = 0
 For i = 1 To nsites
  If DM.Text2 = sitefile(i) Then ix = i
  If DM.Text1 = sitelst(i) Then ix = i
 Next i
 
 Change = 0
 If ix <> 0 Then
   test = MsgBox("File name or full name exists - Overwrite?", 1, "WARNING!")
   If test = 1 Then
     test = MsgBox("Are you sure?", 1, "WARNING")
      If test = 2 Then
       DM.Visible = False
      Else
       sitelst(ix) = fil(DM.Text1)
       sitefile(ix) = DM.Text2
       Change = 1
      End If
   End If
 Else
    nsites = nsites + 1
    sitelst(nsites) = fil(DM.Text1)
    sitefile(nsites) = trunc(DM.Text2)
    PnET.SiteComb.AddItem sitelst(nsites)
    Change = 1
 End If

 If Change = 1 Then
  Close #5
  '    Change from "d:\pnet\data\" ==> Projpath
  OpSiteFile$ = PnET.ProjPath + trunc(projfile(ThisProj)) + "\" + trunc(DM.Text2) + ".sit"
  Open OpSiteFile$ For Output As #5
  Print #5, "File Diretory *********************************************"
  Print #5, PnET.InDir
  Print #5, "SiteVariables *********************************************"
  Print #5, "LAT     WHC    Climate file"
  Print #5, f8(S.Lat) + f8(S.WHC) + Left$(S.ClimFile, 8)
  Print #5, "Initial Conditions *****************************************"
  Print #5, "BudC    WoodC   PlantC   NRatio  PlantN  FolMass WoodMass RootMass"
  Print #5, f8(S.BudC) + f8(S.WoodC) + f8(S.PlantC) + f8(S.NRatio) + f8(S.PlantN) + f8(S.FolMass) + f8(S.WoodMass) + f8(S.RootMass)
  Print #5, "SnowPack Dwater Water   HumusM   HumusN  NH4     DeadWood"
  Print #5, f8(S.SnowPack) + f8(S.DWater) + f8(S.Water) + f8(S.HOM) + f8(S.HON) + f8(S.NH4) + f8(S.DeadWoodM)
  Print #5, "Scenario - for CN ****************************************"
  Print #5, "Run Model From/To"
  Print #5, f8(S.RunModelFrom) + f8(S.RunModelTo)
  Print #5, "Run Climate File From/To"
  Print #5, f8(S.RealClimFrom) + f8(S.RealClimTo)
'   changed when .sit file modified to ramp 0 to 1 fraction August 1999
  Print #5, "   From  TO  FromYr   ToYr      For Climate Change Scenario"
  Print #5, f5(SC.DelTMaxFrom), f5(SC.DelTMaxTo), f6(SC.DelTMaxFromYr), f6(SC.DelTmaxToYr), "DeltTMax"
  Print #5, f5(SC.DelTMinFrom), f5(SC.DelTMinTo), f6(SC.DelTminFromYr), f6(SC.DelTminToYr), "DelTMin"
  Print #5, f5(SC.DelPrecFrom), f5(SC.DelPrecTo), f6(SC.DelPrecFromYr), f6(SC.DelPrecToYr), "DelPrec"
  Print #5, f5(SC.DelParFrom), f5(SC.DelParTo), f6(SC.DelPARFromYr), f6(SC.DelParToYr), "DelPar"
  Print #5, f5(SC.DelWUEFrom), f5(SC.DelWUETo), f6(SC.DelWUEFromYr), f6(SC.DelWUEToYr), "DelWUE"
  Print #5, f5(SC.CO2From), f5(SC.CO2To), f6(SC.CO2FromYr), f6(SC.CO2ToYr), "CO2"
  Print #5, f5(SC.O3From), f5(SC.O3To), f6(SC.O3FromYr), f6(SC.O3ToYr), "O3"
  Print #5, f5(SC.NO3WetFrom), f5(SC.NO3WetTo), f6(SC.NO3WetFromYr), f6(SC.NO3WetToYr), "NO3Wet"
  Print #5, f5(SC.NO3DryFrom), f5(SC.NO3DryTo), f6(SC.NO3DryFromYr), f6(SC.NO3DryToYr), "NO3Dry"
  Print #5, f5(SC.NH4WetFrom), f5(SC.NH4WetTo), f6(SC.NH4WetFromYr), f6(SC.NH4WetToYr), "NH4Wet"
  Print #5, f5(SC.NH4DryFrom), f5(SC.NH4DryTo), f6(SC.NH4DryFromYr), f6(SC.NH4DryToYr), "NH4Dry"
'  end changes from Aug 99
  Print #5, "FertNO3  FertNH4 YrStart  YrEnd  MonStart MonEnd"
  Print #5, f8(SC.FertNO3) + f8(SC.FertNH4) + f8(SC.FertYrStart) + f8(SC.FertYrEnd) + f8(SC.FertDOYStart) + f8(SC.FertDOYEnd)
  Print #5, " AgFrom  AgTo    Remove"
  Print #5, f8(SC.AgFrom) + f8(SC.AgTo) + f8(SC.AgRem)
  Print #5, "# of Harvests"
  nharv = 0
  For i = 0 To 5
    If SC.HarvYear(i) <> "" Then nharv = nharv + 1
  Next i
  Print #5, f8(nharv)
  Print #5, "  Year   Intens   RemFrac  SLossFrac"
  For i = 0 To nharv - 1
    Print #5, f8(SC.HarvYear(i)) + f8(SC.HarvIntens(i)) + f8(SC.RemFrac(i)) + f8(SC.SLossFrac(i))
  Next i
  Print #5, "FolRegen"
  Print #5, f8(SC.FolRegen)
 End If
Close #5

   For i = harvno To 5
     HarvYear(i) = "": HarvIntens(i) = "": RemFrac(i) = "": SLossFrac(i) = ""
   Next i

PnET.SiteComb = fil(DM.Text1)
stype = nsites
'    Change from "d:\pnet\data\" ==> Projpath
Open PnET.ProjPath + trunc(projfile(ThisProj)) + "\pnetsite.lst" For Output As #5
Print #5, nsites
For i = 1 To nsites
  Print #5, sitelst(i) + sitefile(i)
Next i
Close #5

End Sub

Sub KeepVeg()

 ix = 0
 For i = 1 To ntypes
  If DM.Text2 = typfile(i) Then ix = i
  If DM.Text1 = typlst(i) Then ix = i
 Next i

 Change = 0
 If ix <> 0 Then
   test = MsgBox("File name or full name exists - Overwrite?", 1, "WARNING!")
   If test = 1 Then
     test = MsgBox("Are your sure?", 1, "WARNING")
      If test = 2 Then
       DM.Visible = False
      Else
       typlst(ix) = fil(DM.Text1)
       typfile(ix) = DM.Text2
       Change = 1
      End If
   End If
 Else
    ntypes = ntypes + 1
    typlst(ntypes) = fil(DM.Text1)
    typfile(ntypes) = trunc(DM.Text2)
    PnET.VegComb.AddItem typlst(ntypes)
    Change = 1
 End If

 If Change = 1 Then
  Close #5
  OpTypeFile$ = PnET.ProjPath + trunc(projfile(ThisProj)) + "\" + trunc(DM.Text2) + ".veg"
  Open OpTypeFile$ For Output As #5
  Print #5, DM.Text1
  Print #5, " AmaxA   AmaxB   HalfSat BFolResp RespQ10 PsnTMin PsnTOpt AmaxFrac"
  Print #5, f8(IN1.AmaxA) + f8(IN1.AmaxB) + f8(IN1.HalfSat) + f8(IN1.BaseFolRespFrac) + f8(IN1.RespQ10) + f8(IN1.PsnTMin) + f8(IN1.PsnTOpt) + f8(IN1.AmaxFrac)
  Print #5, " FolRet  SLWmax  SLWdel  GDDFolS  GddFolE GDDWoodS GDDWoodE SenescStart"
  Print #5, f8(IN1.FolReten) + f8(IN1.SLWmax) + f8(IN1.SLWdel) + f8(IN1.GDDFolStart) + f8(IN1.GddFolEnd) + f8(IN1.GDDWoodStart) + f8(IN1.GDDWoodEnd) + f8(IN1.SenescStart)
  Print #5, "FolMsMx FolMsMn      k  FolNCon  FolRelGMax"
  Print #5, f8(IN1.FolMassMax) + f8(IN1.FolMassMin) + f8(IN1.k) + f8(IN1.FolNCon) + f8(IN1.FolRelGrowMax)
  Print #5, "CFracB  RootAlA RootAlB GRspFrac WdMRespA RootMRF PCReserv MinWoodFol"
  Print #5, f8(IN1.CFracBiomass) + f8(IN1.RootAllocA) + f8(IN1.RootAllocB) + f8(IN1.GRespFrac) + f8(IN1.WoodMRespA) + f8(IN1.RootMRespFrac) + f8(IN1.PlantCReserveFrac) + f8(IN1.MinWoodFolRatio)
  Print #5, "DVPD1   DVPD2   WUECnst PrecIntF FFlowFr       f"
  Print #5, f8(IN1.DVPD1) + f8(IN1.DVPD2) + f8(IN1.WUEConst) + f8(IN1.PrecIntFrac) + f8(IN1.FastFlowFrac) + f8(IN1.f)
  Print #5, " FLPctN  RLPctN  WLPctN  FolNConR FolNRet  MaxNStore"
  Print #5, f8(IN1.FLPctN) + f8(IN1.RLPctN) + f8(IN1.WLPctN) + f8(IN1.FolNConRange) + f8(IN1.FolNRetrans) + f8(IN1.MaxNStore)
  Print #5, "WoodTrn RtTrnA  RtTrnB  RootTrnC"
  Print #5, f8(IN1.WoodTurnover) + f8(IN1.RootTurnoverA) + f8(IN1.RootTurnoverB) + f8(IN1.RootTurnoverC)
  Print #5, "WdLitLs WdCLoss Kho     NImmobA  NImmobB SoilRespA SoilRespB SoilMoistFact"
  Print #5, f8(IN1.WoodLitLossRate) + f8(IN1.WoodLitCLoss) + f8(IN1.Kho) + f8(IN1.NImmobA) + f8(IN1.NImmobB) + f8(IN1.SoilRespA) + f8(IN1.SoilRespB) + f8(IN1.SoilMoistFact)
 End If
 Close #5

PnET.VegComb = fil(DM.Text1)

Open PnET.ProjPath + trunc(projfile(ThisProj)) + "\pnetveg.lst" For Output As #5
Print #5, ntypes
For i = 1 To ntypes
  Print #5, typlst(i) + typfile(i)
Next i
Close #5

End Sub

Function trunc(stringv)
  l = 0
  For i = 1 To 8
    Char$ = Mid(stringv, i, 1)
    If Char$ <> " " Then l = l + 1
  Next i
  trunc = Left$(stringv, l)
End Function

Function ZCos(T)
TA = Abs(T)
If (TA > 1!) Then
  'Print "|arg| for arccos > 1"
   Stop
End If
If (TA < 0.7) Then
   AC = 1.570796 - Atn(TA / Sqr(1 - TA * TA))
Else
   AC = Atn(Sqr(1 - TA * TA) / TA)
End If
If T < 0 Then
   ZCos = 3.141593 - AC
Else
   ZCos = AC
End If
End Function

Function ZMax(T1, T2)
ZMax = Val(T2)
If Val(T1) > Val(T2) Then ZMax = Val(T1)
End Function

Function ZMin(T1, T2)
ZMin = Val(T1)
If Val(T2) < Val(T1) Then ZMin = Val(T2)
End Function

Function ZSin(T)
TA = Abs(T)
If (TA > 1!) Then
   'Print "|arg| for arcsin > 1.0"
   Stop
End If
If (TA < 0.7) Then
   ZSin = Sgn(T) * (Atn(TA / Sqr(1 - TA * TA)))
Else
   ZSin = Sgn(T) * (1.570796 - Atn(Sqr(1 - TA * TA) / TA))
End If
End Function

