Attribute VB_Name = "CN"



Sub CNDOYOut()
  
'*********************** Print monthly variables *************************
  
kludge$ = ""
If IIout3.WaterOption = True Then
  out$ = kludge$ + f4(DOY) + f5(Tmin) + f5(Tmax) + f5(PAR) + f5(Prec) + f5(LAI) + f6(NetPsnMo) + f6(Trans) + f6(Evap) + f6(Drainage) + f6(Water) + f6(SnowPack) + f6((DWater * DVPD))
ElseIf IIout3.CarbonOption = True Then
  out$ = kludge$ + f4(DOY) + f5(Tmin) + f5(Tmax) + f5(PAR) + f5(Prec) + f5(LAI) + f6(GrsPsnMo) + f6(NetPsnMo) + f6(PlantC) + f6(WoodGRespMo + WoodMRespMo) + f6(RootGRespMo + RootMRespMo) + f6(SoilDecResp + WoodDecResp) + f6(NetCBal)
Else
  out$ = kludge$ + f4(DOY) + f5(Tmin) + f5(Tmax) + f5(PAR) + f5(Prec) + f5(LAI) + f6(NetPsnMo) + f6(PlantC) + f6(PlantN) + f6(NetNMin) + f6(NetNitr) + f6(PlantNUptake) + f6(NDrain) + f6(NDrainMgL)
End If
If PrintLevel = 1 And nyears Mod PrintInt = 0 And IIout1.Option3 = True Then
  outpt.Print out$
End If

If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
  Print #3, out$
End If

If IIout1.Option1 = True And RealYear >= Val(IIout2.GraphFrom) And RealYear <= Val(IIout2.GraphTo) Then
  outn = outn + 1
  outdatx(outn) = (nyears - 1) * 365 + DOY
  If IIout2.Check1(0) = 1 Then outdaty(1, outn) = NetCBal
  If IIout2.Check1(1) = 1 Then outdaty(2, outn) = Drainage
  If IIout2.Check1(2) = 1 Then outdaty(3, outn) = FolMass
  If IIout2.Check1(3) = 1 Then outdaty(4, outn) = NDrainMgL
  If IIout2.Check1(4) = 1 Then outdaty(5, outn) = valid1
  If IIout2.Check1(5) = 1 Then outdaty(6, outn) = valid2
  If IIout2.Check1(6) = 1 Then outdaty(7, outn) = valid3
  If IIout2.Check1(7) = 1 Then outdaty(8, outn) = valid4
                   
End If
If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
  Print #5, f6(RealYear); f6(DOY); f7(NetCBal); f8(Drainage); f6(FolMass); _
  f6(NDrainMgL); f6(O3); f8(valid1); f8(valid2); f8(valid3); f8(valid4)
End If
End Sub

Sub CNFinalOut()
'  Remove line below for non-duplication of last line in OYR files
'If IIout1.Option3 = True Or IIout1.Option4 = True Or IIout1.Option2 = True Then Call CNYearOut(istop)

If IIout1.Option1 = True Then
 VarName$(1) = "CBAL": VarName$(2) = "Drain"
 VarName$(3) = "FolMass": VarName$(4) = "[N]"
 VarName$(5) = "V1": VarName$(6) = "V2"
 VarName$(7) = "V3": VarName$(8) = "V4"
  
 XMax = outdatx(1): XMin = outdatx(1)
 For j = 1 To outn - 1
   If outdatx(j) > XMax Then XMax = outdatx(j)
   If outdatx(j) < XMin Then XMin = outdatx(j)
   For i = 1 To 8
     If outdaty(i, j) > YMax(i) Then YMax(i) = outdaty(i, j)
     If outdaty(i, j) < YMin(i) Then YMin(i) = outdaty(i, j)
   Next i
 Next j
    
 YMin(0) = 0
 For i = 1 To 8
  If YMax(i) <> 0 Or YMin(i) <> 0 Then
   If Abs(YMin(i)) > YMax(i) Then YMax(i) = Abs(YMin(i))
   If Abs(YMin(i)) / YMax(i) > YMin(0) Then YMin(0) = Abs(YMin(i)) / YMax(i)
  End If
 Next i
 YMin(0) = YMin(0) * 100

 Call plot("Day", XMax, XMin, 8, VarName$(), YMax(), YMin(), outn, outdatx(), outdaty())
End If
  
If IIout1.Option2 = True Then
 VarName$(1) = "NPPF": VarName$(2) = "NPPW"
 VarName$(3) = "Fol N": VarName$(4) = "N Min"
 VarName$(5) = "Nitr": VarName$(6) = "N Up"
 VarName$(7) = "Leach": VarName$(8) = "N Dep"
 
 XMax = outdatx(1): XMin = outdatx(1)
 For j = 1 To outn
   If outdatx(j) > XMax Then XMax = outdatx(j)
   If outdatx(j) < XMin Then XMin = outdatx(j)
   For i = 1 To 8
     If outdaty(i, j) > YMax(i) Then YMax(i) = outdaty(i, j)
     If outdaty(i, j) < YMin(i) Then YMin(i) = outdaty(i, j)
   Next i
 Next j
  
 YMin(0) = 0
 For i = 1 To 8
  If YMax(i) <> 0 Or YMin(i) <> 0 Then
   If Abs(YMin(i)) > YMax(i) Then YMax(i) = Abs(YMin(i))
   If Abs(YMin(i)) / YMax(i) > YMin(0) Then YMin(0) = Abs(YMin(i)) / YMax(i)
  End If
 Next i
 YMin(0) = YMin(0) * 100
 ixm = 0
 For i = 4 To 8
   If YMax(i) > ixm Then ixm = Int(YMax(i) + 1)
 Next i
 For i = 4 To 8: YMax(i) = ixm: Next i
 Call plot("Day", XMax, XMin, 8, VarName$(), YMax(), YMin(), outn, outdatx(), outdaty())
End If

If IIout1.Option2 = True Or IIout1.Option1 = True Then
  dummy = InputBox("Hit 'OK' to continue", "Output - Hold", , 6000, 7500)
  outpt.Visible = False
End If


End Sub

Sub CNInit()
  
  iday = 0
  ' Add initialization already in Rev4.1  Oct 2001
  RootC = WoodC / 3
  '  Add some initializations Aug 99
  LightEffMin = 1
  lastday = -15
  NewYear = 0
  TotO3Dose = 0
  RealYear = Val(S.RunModelFrom)
' Try opening output files only if on a site run (not a grid)
  If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then

'*************** initialize output file ********************************
  
  Close #3: Close #4: Close #5

  Open PnET.OutDir + ".oal" For Output As #3
  Print #3, "Input Files   ", TypeName$, SiteName$
  outputline$ = "Input climate file: " + opClimFile$ + _
     "Scenario File: " + Trim(sitefile(stype)) + ".sit"
  Print #3, outputline$
  today$ = Date$
  nyrs$ = S.RunModelTo - S.RunModelFrom
' Label output with checkboxes for O3 and CO2
  ozstring$ = " No ozone,"
  co2string$ = " Fixed CO2 " + SC.FixedCO2
  If SC.UseO3 = 1 Then
  ozstring$ = " ozone included, "
  End If
  If SC.CCRamp = 1 Then
  co2string$ = " Using Mauna Loa CO2 ramp "
  End If
  outputline$ = today$ + " Username Pnet-Cn run for" + nyrs + " years" _
       + ozstring$ + co2string$
  Print #3, outputline$
  
  Open PnET.OutDir + ".ody" For Output As #5
  Print #5, "Input Files   ", TypeName$, SiteName$
  outputline$ = "Input climate file: " + opClimFile$ + _
   "Scenario File: " + Trim(sitefile(stype)) + ".sit"
  Print #5, outputline$
  today$ = Date$
  nyrs$ = S.RunModelTo - S.RunModelFrom

  outputline$ = today$ + " Username Pnet-Cn run for" + nyrs + " years" _
    + ozstring$ + co2string$
  Print #5, outputline$
  Print #5, " YEAR   DOY   NetCBal   Drain FolMass   mg/L N   O3  Valid1  Valid2  Valid3  Valid4"


  Open PnET.OutDir + ".oyr" For Output As #4
  Print #4, "Input Files   ", TypeName$, SiteName$
  outputline$ = "Input climate file: " + opClimFile$ + _
     "Scenario File: " + Trim(sitefile(stype)) + ".sit"
  Print #4, outputline$
  outputline$ = today$ + " Username Pnet-Cn run for " + nyrs + " years" _
      + ozstring$ + co2string$
  Print #4, outputline$
  ' Update in Rev 5.0-1.4vb to format of .oyr file column headers
  Print #4, "  YEAR  NPPFol NPPWood  NEP FolNCon    NMin     Nitr" _
     ; "      NUp    Leach  O3ppb  NDep   Prec   valid1   valid2   valid3   valid4 "
End If
'*************************** initialize *******************************
 
 If IIout1.Option3 = True Or IIout1.Option4 = True Then
   outpt.Visible = True: outpt.Height = 8500
   PrintLevel = 1             ' no graphical output - print tables to outpt form
 Else
   PrintLevel = 0             ' graphical output - do not print tables to outpt form
 End If

 Call CNYrTitles

 
  
  For j = i To 3720          ' initialize output arrays and max and min values
    outdatx(j) = 0
    For i = 1 To 8
      outdaty(i, j) = 0
    Next i
  Next j

  For i = 1 To 8
    YMax(i) = 0: YMin(i) = 0
  Next i
  XMax = 0: XMin = 0

  GDDTot = 0
  NRatioNit = NRatio
  RootNSinkEff = 0.5: NetNMinLastYr = 10
  outn = 0

End Sub

Sub CNNewYear()
Dim leapyr As Integer
'If nyears > 1 Then RealYear = RealYear + 1
' try similar code in Rev 4.1
If (iday <> 0) Then
    RealYear = RealYear + 1
    HarvYet = 0: NetNMinLastYr = NetNMinYr
End If
leapyr = Int(RealYear / 4) * 4 - RealYear
If (leapyr = 0) Then daysinmo(2) = 29


'If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
 'If RealYear <= Val(S.RealClimFrom) Or RealYear > Val(S.RealClimTo) Then
  'Close #2
  'Open opClimFile$ For Input As #2
  'Line Input #2, temp$
  'Line Input #2, temp$

'  Input #2, yr, yod
' End If
'End If

'************** Initialize annual and total variables

GDDTot = 0: WoodMRespYr = 0
totTrans = 0: TotPsn = 0: TotGrossPsn = 0: TotDrain = 0: TotPrec = 0: TotEvap = 0
MaxFolMassYr = FolMass: DropSwitch = 0
FolProdCYr = 0: WoodProdCYr = 0: RootProdCYr = 0
FolMRespYr = 0: WoodMRespYr = 0: RootMRespYr = 0
FolGRespYr = 0: WoodGRespYr = 0: RootGRespYr = 0
TotAnnFolMass = 0: ixFolMass = 0
GDDFolEff = 0: GDDWoodEff = 0: OldGDDFolEff = 0: OldGDDWoodEff = 0
Dwatertot = 0: DwaterIx = 0: NDrainYr = 0
NetNMinYr = 0: GrossNMinYr = 0: PlantNUptakeYr = 0: GrossNImmobYr = 0
TotalLitterMYr = 0: TotalLitterNYr = 0
NetNitrYr = 0: AllocYr = 0: TotDepNYr = 0
SoilDecRespYr = 0: WoodDecRespYr = 0
PosCBalMassTot = 0: PosCBalMassIx = 0
LightEffMin = 1
'   Add for Ozone initialization
TotO3Dose = 0
For nlayer = 1 To 50
O3Effect(nlayer) = 0
Next nlayer

'********** Initialize graph or print headers *************************
Call CNYrTitles
  
End Sub

Sub CNTrans()

'*************************************************************************
'This routine calculates litter production and N content
'It also keeps track of internal available C and N pools in plants
'and from this calculates plant sink strength for N.
'*************************************************************************

RootTurnover = Val(RootTurnoverA) - (RootTurnoverB * NetNMinLastYr) + (RootTurnoverC * NetNMinLastYr ^ 2)
If RootTurnover > 2.5 Then RootTurnover = 2.5
If RootTurnover < 0.1 Then RootTurnover = 0.1
RootTurnover = RootTurnover * (DaySpan / 365)
If BiomLossFrac > RootTurnover Then RootTurnover = BiomLossFrac
RootLitM = RootMass * RootTurnover
RootLitN = RootLitM * (RootMassN / RootMass)
RootMass = RootMass - RootLitM
RootMassN = RootMassN - RootLitN

If BiomLossFrac > 0 Then
  WoodLitM = WoodMass * BiomLossFrac * (1 - RemoveFrac)
  WoodLitN = WoodMassN * BiomLossFrac * (1 - RemoveFrac)
  WoodHarv = WoodMass * BiomLossFrac * RemoveFrac
  WoodHarvN = WoodMassN * BiomLossFrac * RemoveFrac
  WoodMass = WoodMass * (1 - BiomLossFrac)
  WoodMassN = WoodMassN * (1 - BiomLossFrac)
Else
  WoodLitM = WoodMass * WoodTurnover * (DaySpan / 365)
  WoodLitN = WoodMassN * WoodTurnover * (DaySpan / 365)
  WoodMass = WoodMass - WoodLitM
  WoodMassN = WoodMassN - WoodLitN
End If

DeadWoodM = DeadWoodM + WoodLitM
DeadWoodN = DeadWoodN + WoodLitN
WoodMassLoss = DeadWoodM * WoodLitLossRate * (DaySpan / 365)
WoodTransM = WoodMassLoss * (1 - WoodLitCLoss)
WoodDecResp = (WoodMassLoss - WoodTransM) * CFracBiomass
WoodDecRespYr = WoodDecRespYr + WoodDecResp
WoodTransN = (WoodMassLoss / DeadWoodM) * DeadWoodN
DeadWoodM = DeadWoodM - WoodMassLoss
DeadWoodN = DeadWoodN - WoodTransN




'*******************************************************************************
FolNLoss = FolLitM * (FolNCon / 100)
Retrans = FolNLoss * FolNRetrans
PlantN = PlantN + Retrans
FolLitN = FolNLoss - Retrans
'End If


If BiomLossFrac > 0 Then
  If Remove < 1 Then
    FolHarv = 0: FolHarvN = 0
    FolLitM = FolLitM + (FolMass * BiomLossFrac)
    FolLitN = FolLitN + (FolMass * BiomLossFrac * (FolNCon / 100))
  Else
    FolHarv = FolMass * BiomLossFrac
    FolHarvN = FolHarv * FolNCon / 100
  End If
  FolMass = FolMass * (1 - BiomLossFrac)
  PlantC = PlantC * (1 - BiomLossFrac)
  PlantN = PlantN + (MaxNStore - PlantN) * BiomLossFrac
End If


TotalLitterM = FolLitM + RootLitM + WoodTransM
TotalLitterN = FolLitN + RootLitN + WoodTransN

If AgHarv = 1 Then
  TotalLitterM = TotalLitterM * (1 - SC.AgRem)
  TotalLitterN = TotalLitterN * (1 - SC.AgRem)
  WoodMass = WoodMass * (1 - SC.AgRem * (DaySpan / 365))
  WoodMassN = WoodMassN * (1 - SC.AgRem * (DaySpan / 365))
End If

TotalLitterMYr = TotalLitterMYr + TotalLitterM
TotalLitterNYr = TotalLitterNYr + TotalLitterN

End Sub

Sub CNYearOut(istop)
' Calculate NEP for CN only. Moved from AllocateYr.
'NEP = TotPsn - FolGRespYr - WoodMRespYr - WoodGRespYr - SoilDecRespYr
NEP = TotPsn - FolGRespYr - WoodDecRespYr - WoodMRespYr - WoodGRespYr - SoilDecRespYr - RootMRespYr - RootGRespYr
' ************ Print Yearly varaibles **************************************

FolN = (FolMass * FolNCon / 100): FolC = FolMass * CFracBiomass
TotalN = FolN + WoodMassN + RootMassN + HON + NH4 + NO3 + BudN + DeadWoodN + PlantN
TotalM = (BudC / CFracBiomass) + FolMass + (WoodMass + WoodC / CFracBiomass) _
         + RootMass + DeadWoodM + HOM + (PlantC / CFracBiomass)
ix = 0
'*********************** Print annual totals ****************************
If IIout1.Option3 = True Or IIout1.Option4 = True Then
 If PrintLevel = 1 And (nyears Mod PrintInt = 0 Or iday = Val(ndays)) Then
   ix = 1
   outpt.Print "*************************************************************************************************"
   If iday = Val(ndays) Then
     outpt.Print: outpt.Print "Final Year", f7(RealYear): outpt.Print
   End If
  
   outpt.Print
   outpt.Print "    ------water balance (cm/yr) --------   gC/m2.yr -NPP g organic matter/m2.yr-"
   outpt.Print "    precip     trans      evap  drainage   net psn    foliage    wood  fine root"
   out$ = "   " + f6(TotPrec) + "   " + f6(totTrans) + "   " + f6(TotEvap) + "   " + f6(TotDrain) + "   " _
   + f6(Int(TotPsn)) + "   " + f6(Int(NPPFolYr)) + "   " + f6(Int(NPPWoodYr)) + "   " + f6(Int(NPPRootYr))
   outpt.Print out$
   outpt.Print
   outpt.Print " --------------------   Carbon Balance (g/m2.yr)   -----------------------"
   outpt.Print " grspsn  netpsn  folgrs  folgrw  wdmrsp  wdgrsp  wdgrow  rtmrsp  rtgrsp  rtgrow  soilrs wooddec     NEP"
   out$ = f7(TotGrossPsn) + f7(TotPsn) + f7(FolGRespYr) + f7(FolProdCYr) + f7(WoodMRespYr) + f7(WoodGRespYr) _
   + f7(WoodProdCYr) + f7(RootMRespYr) + f7(RootGRespYr) + f7(RootProdCYr) + f7(SoilDecRespYr) + f7(WoodDecRespYr) + f7(NEP)
   outpt.Print out$
   outpt.Print
   outpt.Print " -------  Nitrogen Balance (gN/m2.yr)  --------           Next Year's "
   outpt.Print " TotNDep  Drain NetNMin Nitrif. NUptake  Litter         NRatio FolNCon "
   outpt.Print f8(TotDepNYr) + f8(NDrainYr) + f8(NetNMinYr) + f8(NetNitrYr) + f8(PlantNUptakeYr) + f8(TotalLitterNYr);
   outpt.Print "       ";
   outpt.Print f8(NRatio) + f8(FolNCon)
   outpt.Print
   outpt.Print " ----------------------------- Pool(g/m2)  ------------------------------------  "
   outpt.Print "            Bud Foliage    Wood    Root Dd Wood   Humus   Plant NH4+NO3   Total"
   outpt.Print " Organic";
   outpt.Print f8(BudC / CFracBiomass) + f8(FolMass) + f8(WoodMass + (WoodC / CFracBiomass)) + f8(RootMass) + f8(DeadWoodM) + f8(HOM) + f8(PlantC / CFracBiomass) + f8(0) + f8(TotalM)
   outpt.Print "       N";
   outpt.Print f8(BudN) + f8(FolN) + f8(WoodMassN) + f8(RootMassN) + f8(DeadWoodN) + f8(HON) + f8(PlantN) + f8((NH4 + NO3)) + f8(TotalN)

   dummy = InputBox("Hit 'OK' to continue,       'S' and 'OK' to stop.", "Output - Hold", , 6000, 7500)
   If dummy = "s" Or dummy = "S" Then
     istop = 1
   Else
     istop = 0
   End If

 End If
End If
' Add check here for Grid type Aug 99 and skip if not last pixel
If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
 If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
   Print #3,
   Print #3, "    ------water balance (cm/yr) --------   gC/m2.yr -NPP g organic matter/m2.yr-"
   Print #3, "    precip     trans      evap  drainage   net psn    foliage    wood  fine root"
   out$ = "   " + f6(TotPrec) + "   " + f6(totTrans) + "   " + f6(TotEvap) + "   " + f6(TotDrain) _
   + "   " + f6(Int(TotPsn)) + "   " + f6(Int(NPPFolYr)) + "   " + f6(Int(NPPWoodYr)) + "   " + f6(Int(NPPRootYr))
   Print #3, out$
   Print #3,
   Print #3, " --------------------   Carbon Balances (g/m2.yr)   -----------------------"
   Print #3, " totpsn  folgrs  folgrw  wdmrsp  wdgrsp  wdgrow  rtmrsp  rtgrsp  rtgrow  soilrs wooddec     NEP"
   out$ = f7(TotPsn) + f7(FolGRespYr) + f7(FolProdCYr) + f7(WoodMRespYr) + f7(WoodGRespYr) + _
   f7(WoodProdCYr) + f7(RootMRespYr) + f7(RootGRespYr) + f7(RootProdCYr) + f7(SoilDecRespYr) + f7(WoodDecRespYr) + f7(NEP)
   Print #3, out$
   Print #3,
   Print #3, " -------  Nitrogen Balance (gN/m2.yr)  --------           Next Year's "
   Print #3, " TotNDep  Drain NetNMin Nitrif. NUptake  Litter         NRatio FolNCon "
   Print #3, f8(TotDepNYr) + f8(NDrainYr) + f8(NetNMinYr) + f8(NetNitrYr) + f8(PlantNUptakeYr) + f8(TotalLitterNYr);
   Print #3, "       ";
   Print #3, f8(NRatio) + f8(FolNCon)
   Print #3,
   Print #3, " ----------------------------- Pool(g/m2)  ------------------------------------  "
   Print #3, "            Bud Foliage    Wood    Root Dd Wood   Humus   Plant NH4+NO3   Total"
   Print #3, " Organic";
   Print #3, f8(BudC / CFracBiomass) + f8(FolMass) + f8(WoodMass + (WoodC / CFracBiomass)) + f8(RootMass) + f8(DeadWoodM) + f8(HOM) + f8(PlantC / CFracBiomass) + f8(0) + f8(TotalM)
   Print #3, "       N";
   Print #3, f8(BudN) + f8(FolN) + f8(WoodMassN) + f8(RootMassN) + f8(DeadWoodN) + f8(HON) + f8(PlantN) + f8((NH4 + NO3)) + f8(TotalN)
 End If
End If

If IIout1.Option2 = True And RealYear >= Val(IIout2.GraphFrom) And RealYear <= Val(IIout2.GraphTo) Then
 outn = outn + 1
 outdatx(outn) = RealYear
  If IIout2.Check1(0) = 1 Then outdaty(1, outn) = NPPFolYr
  If IIout2.Check1(1) = 1 Then outdaty(2, outn) = NPPWoodYr
  If IIout2.Check1(2) = 1 Then outdaty(3, outn) = FolNCon
  If IIout2.Check1(3) = 1 Then outdaty(4, outn) = NetNMinYr
  If IIout2.Check1(4) = 1 Then outdaty(5, outn) = NetNitrYr
  If IIout2.Check1(5) = 1 Then outdaty(6, outn) = PlantNUptakeYr
  If IIout2.Check1(6) = 1 Then outdaty(7, outn) = NDrainYr
  If IIout2.Check1(7) = 1 Then outdaty(8, outn) = TotDepNYr
End If
  
If Left(PnET.ProjType, 1) = "S" Or Left(PnET.ProjType, 1) = "s" Then
  Print #4, f5(RealYear); f7(Int(NPPFolYr)); f7(Int(NPPWoodYr)); f5(Int(NEP)); f6(FolNConOld); _
     f8(NetNMinYr); f8(NetNitrYr); f8(PlantNUptakeYr); _
     f8(NDrainYr); f6(TotO3Dose); f6(TotDepNYr); f6(TotPrec); f8(valid1); f8(valid2); f8(valid3); f8(valid4)
End If

End Sub

Sub CNYrTitles()

outpt.Cls

If IIout1.Option3 = True Or IIout1.Option4 = True Then
 If PrintLevel = 1 And nyears Mod PrintInt = 0 Then
   outpt.Print Title$
   outpt.Print "YEAR: ";
   outpt.Print f7(RealYear)
   outpt.Print "", "", "", "", f5(FolNCon); "%N"
   outpt.Print " ************************************************************************************************"
  If IIout3.WaterOption = True Then
    outpt.Print " oC    oC   j/m2/s cm/mo m2/m2 g/m2 g/m2  --------------- cm -------------- "
    outpt.Print "month min T max T   rad  prec   LAI NetPs  Trans   Evap  drain  water  snow  stress"
  ElseIf IIout3.CarbonOption = True Then
    outpt.Print " oC    oC   j/m2/s cm/mo m2/m2 ---------------------g/m2----------------------------"
    outpt.Print "month min T max T   rad  prec   LAI  GrsPs  NetPs  PlntC  WdRes  RtRes  SlRes   CBal"
  ElseIf IIout3.NitrogenOption = True Then
    outpt.Print " oC    oC   j/m2/s cm/mo m2/m2      ---gC/m2---  -gN/m2-  ---------gN/m2.mo--------  mgN/L"
    outpt.Print "month min T max T   rad  prec   LAI NetPs  PlntC  PlntN   Min.   Nitr. Uptake Leach  Stream"
  End If
 End If
End If

'RealYear = BaseYear + nyears
If RealYear >= Val(IIout1.TabOutFrom) And RealYear <= Val(IIout1.TabOutTo) Then
  Print #3, Title$
  Print #3, "YEAR: ";
  Print #3, f7(RealYear)
  Print #3, "", "", "", "", f5(FolNCon); "%N"
  Print #3, " ************************************************************************************************"
  If IIout3.WaterOption = True Then
    Print #3, " oC    oC umol/m2/s cm/mo m2/m2 g/m2 g/m2  --------------- cm -------------- "
    Print #3, "month min T max T   rad  prec   LAI NetPs  Trans   Evap  drain  water  snow  stress"
  ElseIf IIout3.CarbonOption = True Then
    Print #3, " oC    oC umol/m2/s cm/mo m2/m2 ---------------------g/m2----------------------------"
    Print #3, "month min T max T   rad  prec   LAI GrsPs  NetPs  PlntC  WdRes  RtRes  SlRes   CBal"
  ElseIf IIout3.NitrogenOption = True Then
    Print #3, " oC    oC umol/m2/s cm/mo m2/m2      ---gC/m2---  -gN/m2-  ---------gN/m2.mo--------  mgN/L"
    Print #3, "month min T max T   rad  prec   LAI NetPs  PlntC  PlntN   Min.   Nitr. Uptake Leach  Stream"
  Else
  '   If not explicit, as in case of graphing, use Nitrogen as default
    Print #3, " oC    oC umol/m2/s cm/mo m2/m2      ---gC/m2---  -gN/m2-  ---------gN/m2.mo--------  mgN/L"
    Print #3, "month min T max T   rad  prec   LAI NetPs  PlntC  PlntN   Min.   Nitr. Uptake Leach  Stream"
  End If
End If

End Sub

Sub Decomp()

'*****************************
'    Temperature effect on all soil processes
'*****************************

 tEffSoil = ZMax(Tave, 1)
 TMult = (Exp(0.1 * (Tave - 7.1)) * 0.68) * 1
 WMult = MeanSoilMoistEff

'*******************************************
'    Add litter to Humus pool
'*******************************************

 HOM = HOM + TotalLitterM
 HON = HON + TotalLitterN

'*****************************
'  Humus dynamics
'*****************************
  KhoAct = Kho * (DaySpan / 365)
  DHO = HOM * (1 - Exp(-KhoAct * TMult * WMult))   ' Add C:N effect?
  GrossNMin = DHO * (HON / HOM)
  SoilDecResp = DHO * CFracBiomass
  SoilDecRespYr = SoilDecRespYr + SoilDecResp
  GrossNMinYr = GrossNMinYr + GrossNMin
  HON = HON - GrossNMin
  HOM = HOM - DHO


'*********************************************
'  Immobilization and net mineralization
'*********************************************
  
  SoilPctN = (HON / HOM) * 100
  NReten = (NImmobA + NImmobB * SoilPctN) / 100
  GrossNImmob = NReten * GrossNMin
  HON = HON + GrossNImmob
  GrossNImmobYr = GrossNImmobYr + GrossNImmob
  NetNMin = GrossNMin - GrossNImmob
  
  NH4 = NH4 + NetNMin
  NetNitr = (NH4 * NRatioNit)

  NO3 = NO3 + NetNitr
  NH4 = NH4 - NetNitr


'******************************************************
'       Plant Uptake
'******************************************************

  RootNSinkStr = (ZMin((RootNSinkEff * TMult), 0.98))
  PlantNUptake = (NH4 + NO3) * RootNSinkStr
  If (PlantNUptake + PlantN) > MaxNStore Then
    PlantNUptake = MaxNStore - PlantN
    RootNSinkStr = PlantNUptake / (NO3 + NH4)
  End If
  If PlantNUptake < 0 Then
    PlantNUptake = 0
    RootNSinkStr = 0
  End If
  PlantN = PlantN + PlantNUptake
  PlantNUptakeYr = PlantNUptakeYr + PlantNUptake
 
  NH4Up = NH4 * RootNSinkStr
  NH4 = NH4 - NH4Up
  NO3Up = NO3 * RootNSinkStr
  NO3 = NO3 - NO3Up
 
  NetNMinYr = NetNMinYr + NetNMin
  NetNitrYr = NetNitrYr + NetNitr

End Sub

Sub Leach()

NDrain = FracDrain * NO3
NDrainYr = NDrainYr + NDrain
NDrainMgL = (NDrain * 1000) / (Drainage * 10)
NO3 = NO3 - NDrain

End Sub

Sub PnETCN()
    
    istop = 0
    outpt3.Visible = True
    nyears = 0
    Call CNInit
    iday = 0
    imonth = 0
    nregional = 0
      ' set to 0 for site for routine Scenario
    Call ReadMo
    
nextday:
    iday = iday + 1 ' where else might iday be advanced??
    imonth = imonth + 1
    If (imonth > 12) Then
        imonth = 1
        NewYear = 1
    End If
    Call ReadMo
    If NewYear = 1 And iday <> 1 Then
      Call AllocateYr
      Call CNYearOut(istop)
      If istop = 1 Then GoTo quitit
      nyears = nyears + 1
      'RealYear = BaseYear + nyears
      If RealYear >= Val(S.RunModelTo) Then GoTo endit
      Call CNNewYear
      NewYear = 0
    End If
   
    Call Scenario
    Call AtmEnviron
    Call Phenology(1)
    Call Photosyn
    Call Waterbal
    Call AllocateMo
    Call Phenology(2)
    Call CNTrans
    Call Decomp
    Call Leach
    Call CNDOYOut
   
  GoTo nextday

endit:
  nyears = nyears - 1
  iday = iday - 1
  Call CNFinalOut
quitit:
  Close #1: Close #2: Close #3: Close #4: Close #5
  outpt.Visible = False: outpt3.Visible = False

End Sub
Sub PnETCNGIS()
 Dim npixls As Integer, nrow As Integer, ncol As Integer
 Dim nyrs As Integer, VegTypeCell As Integer, yrr As Integer
 Dim WHCGIS, dom(13) As Integer, Cc As Integer
 Dim kveg As Integer, Pixelid As String * 13
 Dim pixid As Integer, allveg As Integer
 
'  Modifications March 1999 to allow for identification in GIS
'  applications of pixels
'  initialized for unidentified pixels

  istop = 0
  pixid = 0
  Pixelid = " "
  NRamp = 0
  WUEO3 = 0
'   Initialize as NOT climcalc climate type file
  Cc = 0
  Close #11: Close #12
  Open PnET.InDir + PnET.GridFile + ".clm" For Input As #11
  Input #11, npixls, nrow, ncol, nyrs, climtype$
  Open PnET.OutDir + "GISOut.log" For Output As #12
  outputline$ = "Input Climate File: " + PnET.InDir + PnET.GridFile + ".clm" _
    + "  Scenario file: " + Trim(sitefile(stype)) + ".sit"
  Print #12, outputline$
  today$ = Date$
  ozstring$ = " No ozone,"
  co2string$ = " Fixed CO2 " + SC.FixedCO2
  If SC.UseO3 = 1 Then
  ozstring$ = " ozone included, "
  End If
  If SC.CCRamp = 1 Then
  co2string$ = " Using Mauna Loa CO2 ramp "
  End If
  outputline$ = today$ + " Pnet-Cn run for " + PnET.NYrsCell + " years" _
     + ozstring$ + co2string$
  Print #12, outputline$
  
  If (Left(PnET.ProjType, 1) = "G" Or Left(PnET.ProjType, 1) = "g") Then
    nregional = 1      '  set to 1 for grid, 0 for site
  End If
  outputline$ = " nregional = " + Str(nregional)
  Print #12, outputline$
 
  Print #12, "Identifier       LAT    LON    ELEV   WHC   VegT  Prec   NDep   O3Dose   ET  Drain    Psn  NPPFol NPPWd  NPPRt   NPP    NEP    NMin   Nitr NLeach"
  outpt3.Visible = True
 ' If nyrs <> PnET.NYrsCell Then
 ' PnET.NYrsCell = nyrs
 ' End If
  
 If Left$(climtype$, 1) = "C" Or Left$(climtype$, 1) = "c" Then
   Call ClimCalcIn
   Cc = 1
 End If

 If Right$(climtype$, 1) = "I" Or Right$(climtype$, 1) = "i" Then
    pixid = 1
 End If
 
 For i = 1 To Val(PnET.NumGridCells)
 '  Re-initalize totals  and initializations for next grid cell
  ' Call UpdateData
   Call SiteInit
 
   outpt3.Cls: outpt3.Print "Cell #":  outpt3.Print i
     
    If (pixid = 1) Then
        Input #11, Lat_in, Lon, Elev, VegTypeCell, WHCGIS, Pixelid
    Else
        Input #11, Lat_in, Lon, Elev, VegTypeCell, WHCGIS
    End If
     
    If (VegTypeCell <> -9999) Then
'   process pixel only if all of the above variables show presence of real data
        PnET.VegComb = typlst(Val(VegTypeCell))
    ' Always read in the vegetation parameters for the next pixel
        Call PnET.VegComb_Change
    End If
'  this is a fix to the problem that Lat is read from SIT file
'  and is a constant value, vs the changing value of the GIS
'  climate data.
    Lat = Lat_in
    WHC = WHCGIS

   If Left$(climtype$, 1) = "R" Or Left$(climtype$, 1) = "r" Then
     For j = 1 To 12
       Input #11, yrr, dom(j), TMaxGIS(j), TMinGIS(j), PARGIS(j), PrecGIS(j), NH4GIS(j), NO3GIS(j), O3GIS(j), CO2GIS(j)
     Next j
   Else
     Call ClimCalc(Lat, Lon, Elev)
   End If

skipread:
  If (VegTypeCell <> -9999 And VegTypeCell <> 100) Then
   'outpt3.Visible = True
    nyears = 1
    Call CNInit
    iday = 0
    dom(13) = 382
 '   If (Cc = 1) Then
 '       DaySpan = 30
 '   End If
 
   For iyr = 1 To PnET.NYrsCell
     For imo = 1 To 12
       imonth = imo
       iday = (iyr - 1) * 12 + imo
       If (Cc = 1) Then
        DOY = imo * 30.5 - 15
        DaySpan = daysinmo(imo)
       Else
        DOY = dom(imo)
        DaySpan = daysinmo(imo)
'        DaySpan = dom(imo + 1) - dom(imo)
       End If
       Tmaxin = TMaxGIS(imo): Tminin = TMinGIS(imo): PARin = PARGIS(imo): Precin = PrecGIS(imo)
       NH4in = NH4GIS(imo): NO3in = NO3GIS(imo): O3 = O3GIS(imo) / 1000: co2in = CO2GIS(imo)
      
      If imo = 1 And iday <> 1 Then
        Call AllocateYr
        Call CNYearOut(istop)
        nyears = nyears + 1
        Call CNNewYear
      End If
   
      Call Scenario
      Call AtmEnviron
      Call Phenology(1)
      Call Photosyn
      Call Waterbal
      Call AllocateMo
      Call Phenology(2)
      Call CNTrans
      Call Decomp
      Call Leach
      Call CNDOYOut
     Next imo
   Next iyr
   Call CNFinalOut

   Close #1: Close #2: Close #3: Close #4: Close #5
   'outpt.Visible = False: outpt3.Visible = False
Else
    TotPrec = -999.9
    totTrans = -990.9
    TotEvap = -9
    TotDrain = -999.9
    TotPsn = -999.9
    NPPFolYr = -999.9
    NPPWoodYr = -999.9
    NPPRootYr = -999.9
    NetNMinYr = -999.9
    NetNitrYr = -999.9
    NDrainYr = -999.9
  End If
  'End of test for undefined pixels (more than 50% water)

 Print #12, Pixelid, f6(Lat); f6(Lon); f6(Elev); f6(WHC); f6(VegTypeCell);
 ' f6(TotPrec); f6(totTrans + TotEvap) + f6(TotDrain); f6(Int(TotPsn)); f6(Int(NPPFolYr)); f6(Int(NPPWoodYr)); f6(Int(NPPRootYr)); f6(NetNMinYr); f6(NetNitrYr); f6(NDrainYr)
 Print #12, f6(TotPrec); f6(TotDepNYr); f6(TotO3Dose); f6(totTrans + TotEvap) + f6(TotDrain);
 Print #12, f6(Int(TotPsn)); f6(Int(NPPFolYr)); f6(Int(NPPWoodYr));
 Print #12, f6(Int(NPPRootYr)); f6(Int(NPPYr)); f6(Int(NEP)); f6(NetNMinYr); f6(NetNitrYr); f6(NDrainYr)

Next i
Close #11: Close #12
End Sub
